#ifndef FWIINTEGRALOPERATOR_H
#define FWIINTEGRALOPERATOR_H
#include "FWIRKOperator.hpp"
class integralOperator {
    const RKOperator& RKOp;
    inteOptions opt;
    public:
    integralOperator(const RKOperator& RKOp_): RKOp(RKOp_),opt(RKOp.getOpt()) {}

  void run(const Vectors &WaveFieldPoint, Vectors &WaveFieldEvaluation) const {
    if(opt.fwd){
      Vector tmp(WaveFieldEvaluation[0]);
      tmp.Clear();
      for (int i =0 ; i<WaveFieldPoint.size(); ++i) {
        RKOp.loopFwdOneStep(WaveFieldPoint,tmp,i);
        WaveFieldEvaluation[i] += tmp;
      }
    }
    if(!opt.discrete && !opt.fwd) {
      Vector tmp(WaveFieldEvaluation[0]);
      tmp.Clear();
      for (int i = WaveFieldPoint.size() - 1; i > 0; --i) {
        RKOp.loopBwdOneStep(WaveFieldPoint, tmp, i);
        WaveFieldEvaluation[i] += tmp;
      }
    }
  }

};
#endif
