//
// Created by cr on 14.10.21.
//

#ifndef FWI_FWILINEARIZEDINTEGRALOPERATOR_HPP
#define FWI_FWILINEARIZEDINTEGRALOPERATOR_HPP


#include "Assembler/FWILinearizedAssembler.hpp"
#include "Helper/VectorsIntegrator.hpp"

class FWILinearizedIntegralOperator {
  const Vectors &WaveFieldPoint;
  FWILinearizedAssembler linAssembler;
  VectorsIntegrator VecsInte;
public:
  FWILinearizedIntegralOperator(
      std::shared_ptr<FWIVAcousticInversionProb> problem_fwd_,
      const std::unordered_map<Point, DGAcousticElement *> &eleCache_,
      const Vector &materialPoint_, const Vectors &WaveFieldPoint_, double dt,
      int rkorder);

  void Evaluate(const Vector &materialDirection,
                Vectors &LinearizedEvaluation) const;

};


#endif //FWI_FWILINEARIZEDINTEGRALOPERATOR_HPP
