//
// Created by cr on 09.11.22.
//

#ifndef FWI_FWITIMESOLVER_HPP
#define FWI_FWITIMESOLVER_HPP

#include "Assemble.hpp"
#include "Helper/ABCHandler.hpp"
#include "Observation/DGSeismogram.hpp"
#include "Observation/FWIObservationOperatorDGTS.hpp"
#include "Vector.hpp"

class FWITimeSolver {
    const std::shared_ptr<ABCHandler> &ABCH;
    int rkorder = -2;
    const Vector &WaveVectorUnpadded;
public:
    FWITimeSolver(const Vector &wVU, const std::shared_ptr<ABCHandler> &ABCH_, int rkorder_) :
            WaveVectorUnpadded(wVU), ABCH(ABCH_), rkorder(rkorder_) {}

    void SolveAndMeasure(const std::shared_ptr<ILinearTimeAssemble> &assemble,
                         const FWIObservationOperatorDGTS &Obs, DGSeismogram &s, Vectors *U_m);

    void Solve(const std::shared_ptr<ILinearTimeAssemble> &assemble, Vectors &U_m);

};


#endif //FWI_FWITIMESOLVER_HPP
