//
// Created by cr on 10.11.22.
//

#include "FWIObservationOperatorDGTS.hpp"

#include <memory>

#include "DGSeismogram.hpp"
#include "Helper/FWIMppHelpers.hpp"
#include "lib6_app/seismogram/ObservationSpecification.hpp"

void FWIObservationOperatorDGTS::MeasureFullWave(const Vectors &U,
                                                 DGSeismogram &s) const {
    const auto &spec = spaceOp->GetSpecification();
    for (const auto &receiver: spaceOp->GetSpaceSupport()) {
        for (int step = 0; step < spec.GetNumberOfTimeSteps(); ++step) {
            FWIState Measure(0.0, Mask->GetStateComps()) ;
            auto timelist = timeOp->TimeSupport(step);
            for (auto time: timelist) {
                Measure += spaceOp->GetSpaceValue(U[time], receiver.first, receiver.second) *
                              (*timeOp)(spec.TimeAtStep(time));
            }
            Mask->mask(Measure);
          s.GetData().SetMeasurement(receiver.first, spec.TimeAtStep(step), Measure);
        }
    }
}

void FWIObservationOperatorDGTS::MeasureSingleWaveField(const Vector &U,
                                                        DGSeismogram &s, int step) const {
  if (timeOp->TimeSupport(step).size() <= 1) {
    for (const auto &receiver : spaceOp->GetSpaceSupport()) {
      auto *Measure = new FWIState(0.0, Mask->GetStateComps());
      double t = spaceOp->GetSpecification().TimeAtStep(step);
      (*Measure) = spaceOp->GetSpaceValue(U, receiver.first, receiver.second);
      Mask->mask(*Measure);
      s.GetData().SetMeasurement(receiver.first,
                                 s.GetData().GetParaDat().spec.TimeAtStep(step),
                                 *Measure);
      delete Measure;
    }
  } else
    THROW("Can't use this Measure Single WaveField with a Time Measurement "
          "with Support 1")
}






