//
// Created by cr on 11.11.22.
//

#ifndef FWI_OBSERVATIONCREATOR_HPP
#define FWI_OBSERVATIONCREATOR_HPP

#include "FWIObservationOperatorDGTS.hpp"

class ObservationCreator {
protected:
    std::shared_ptr<EleCacheType> eleCache;
    const Mesh &mesh;
    std::shared_ptr<ObservationSpecification> spec;
    std::unique_ptr<MeasureMask> Mask;
    std::unique_ptr<FWIObservationOperatorSpaceDGTS> spaceOp;
    std::unique_ptr<FWIObservationOperatorTimeDGTS> timeOp;
    int numL = -1;
    std::string obsSpec;
    int MeasureComp = 0;

    void getSpec();

    void readConfig();

public:

    explicit ObservationCreator(std::shared_ptr<EleCacheType> eleCache_,
                                 const Mesh &mesh_, int numL_);

    ObservationCreator &WithTimeOp(std::unique_ptr<FWIObservationOperatorTimeDGTS> timeOp_);

    ObservationCreator &WithSpaceOp(std::unique_ptr<FWIObservationOperatorSpaceDGTS> spaceOp_);

    ObservationCreator &WithMask(std::unique_ptr<MeasureMask> Mask_);

    ObservationCreator &WithSpec(std::shared_ptr<ObservationSpecification> spec_);

    FWIObservationOperatorDGTS *Create();

    auto CreateShared() -> std::shared_ptr<FWIObservationOperatorDGTS>;

    auto CreateUnique() -> std::unique_ptr<FWIObservationOperatorDGTS>;
};
void printResult(double t0, double dt, double T, std::vector<Point> &receiver_positions);

#endif  // FWI_OBSERVATIONCREATOR_HPP
