//
// Created by cr on 12.09.22.
//

#ifndef FWI_WAVEPROBLEMFROMIMAGES2D_HPP
#define FWI_WAVEPROBLEMFROMIMAGES2D_HPP

#include "FWIAbstractInterfaceDGTSVA.hpp"
#include "Problems/FWIProblemsDGTSVA.hpp"
#include "Problems/FWIAcousticInversionProb.hpp"
#include "ParameterImage.hpp"

class WaveProblemFromImages2D : public FWIVAcousticInversionProb {
    std::pair<double, double> LeftRight;
    std::pair<double, double> BottomTop;
    double impedance_bg = 1.0;
    int problemLevel = -1;
    double mlLength = 1.0; //macro-level length of cell
    std::shared_ptr<ParameterImage> RhoImage = nullptr;
    std::shared_ptr<ParameterImage> VpImage = nullptr;
    std::shared_ptr<ParameterImage> TaupImage = nullptr;
    std::shared_ptr<ParameterImage> RhoInitialImage = nullptr;
    std::shared_ptr<ParameterImage> VpInitialImage = nullptr;
    std::shared_ptr<ParameterImage> TaupInitialImage = nullptr;
    void readImage(const std::string &, std::shared_ptr<ParameterImage> &,
                   std::shared_ptr<ParameterImage> &);

  public:
    const char *Name() const override { return "WaveProblemFromImages2d_RHS"; }

    WaveProblemFromImages2D(const Point &minP, const Point &maxP, int _numL);

    double Rho(const Cell &c, const Point &P) const override;

    double V_p(const Cell &c, const Point &P) const override;

    double Tau_p(const Cell &c, const Point &P) const override;

    ~WaveProblemFromImages2D() override = default;
};

#endif //FWI_WAVEPROBLEMFROMIMAGES2D_HPP
