//
// Created by cr on 18.11.22.
//

#ifndef FWI_FWILINOPRED_HPP
#define FWI_FWILINOPRED_HPP

#include "Assembler/FWIRhsAssemblerLinearized.hpp"
#include "DGVAcousticAssembleCombined.hpp"
#include "DGVAcousticMatrixAssembler.hpp"
#include "FWITimeSolver.hpp"
#include "VAcousticMatFromVec.hpp"
#include "Vector.hpp"

class FWILinOpRed {
protected:
    const std::shared_ptr<FWIVAcousticInversionProb> &prob;
    const Vectors &U_m;
    const Vector &m;
    const std::shared_ptr<ABCHandler> &PMLH;
    std::shared_ptr<DGVAcousticMatrixAssembler> matrixAssembler = nullptr;
    std::shared_ptr<DGVAcousticPlotter> VAPlotter;
    std::shared_ptr<EleCacheType> eleCache;
    const TimeConf &TConf;
    bool discrete = false;
    std::shared_ptr<DGVAcousticAssembleCombined> getAssembler(const Vector &m_test);

public:
    FWILinOpRed(const Vectors &U_m_, const Vector &m_, const std::shared_ptr<FWIVAcousticInversionProb> &prob_,
                const std::shared_ptr<ABCHandler> &PMLH_, const TimeConf &TConf_,
              std::shared_ptr<EleCacheType> eleCache_,
                bool discrete);

    virtual void Solve(const Vector &m_test, Vectors &U_linearized);

    virtual void SolveAndMeasure(const Vector &m_test, const FWIObservationOperatorDGTS &Obs,
                                 DGSeismogram &s_linearized, Vectors *U_linearized);
};

#endif //FWI_FWILINOPRED_HPP
