//
// Created by cr on 23.08.22.
//

#ifndef FWI_VACOUSTICMATFROMVEC_HPP
#define FWI_VACOUSTICMATFROMVEC_HPP

#include "DGVAcousticMatrixAssembler.hpp"
#include "FWIAbstractInterfaceDGTSVA.hpp"
#include "Helper/ABCHandler.hpp"
#include "Problems/FWIAcousticInversionProb.hpp"

class VAcousticMatFromVec : public DGVAcousticMaterialFromVector {
  static constexpr double Eps = 1e-10;
  std::unique_ptr<Vector> TauP = nullptr;
  const FWIVAcousticInversionProb &prob;
    void fillVector(const FWIVAcousticInversionProb &problem_fwd, const Vector &Mat);
    ABCHandler * handle=nullptr;
 ABCHandlerAAO * handleAAO=nullptr;
public:
  VAcousticMatFromVec(const FWIVAcousticInversionProb &prob, const Vector &Mat,
                                   ABCHandler *handle_ = nullptr,
                                   ABCHandlerAAO *handleAAO_ = nullptr);
    double alpha(const Cell & C,
                       const Point & x) const override{
    return prob.alpha(C,x);
  }
   double alpha1() const override{

    return prob.alpha1();
  }
   double alpha2() const override {
    return prob.alpha2();
  }
    double Rho(const Cell &C, const Point &) const override;

    double Kappa_i(const Cell &C, const Point &, int n) const override;

    double invKappa_i(const Cell &C, const Point &, int n) const override;

    double invTau_i(const Cell &C, const Point &, int n) const override;

    double Kappa(const Cell &C, const Point &x) const override;
};

#endif  // FWI_VACOUSTICMATFROMVEC_HPP
