//
// Created by cr on 14.07.22.
//

#ifndef FWI_FWITESTALLATONCE2D_HPP
#define FWI_FWITESTALLATONCE2D_HPP

#include <string>
#include <map>

using ConfigMap = std::map<std::string, std::string>;
const ConfigMap TestFWIAllAtOnce2DConfigMap{
        {"UseSparseMatrix",                "1"},
        {"ForwardSolver",                  "VADGTS"},
        {"Distribution",                   "RCB"},
        {"Model",                          "FWIInverse_DGTS"},
        {"CountCellsOld",                  "0"},
        {"ConfigVerbose",                  "2"},
        {"dim",                            "2"},
        {"Mesh",                           "SeismogramGrid_test"},
        {"startingValue_",                 "1"},
        {"Preconditioner_M",               "PointBlockJacobi"},
        {"Problem",                        "VAcousticWaveC2Benchmark"},
        {"ReconstructionType",             "AllAtOnce"},
        {"sourceSpace",                    "2"},
        {"useTaper",                       "1"},
        {"taperRadiusSource",              "0"},
        {"taperRadiusReceiver",            "0"},
        {"taperExponent",                  "-0.1"},
        {"taperIgnoreReceiverCells",       "0"},
        {"taperIgnoreSourceCells",         "1"},
        {"Monoparam",                      "Vp"},
        {"numberOfSourcesPerShot",         "1"},
        {"FWISourceWaypoints",             "2"},
        {"FWISourceWaypoint0",             "601, 371"},
        {"FWISourceWaypoint1",             "601, 1621"},
        {"FWISourceCount0",                "2"},
        {"FWISourceIncludeLastWaypoint",   "1"},
        {"SignalFreq",                     "25"},
        {"SignalName",                     "RickerDerivative"},
        {"v_bg",                           "3500"},
        {"x_perturb",                      "900"},
        {"z_perturb_0",                    "600"},
        {"z_perturb_0_value",              "1.05"},
        {"z_perturb_1",                    "900"},
        {"z_perturb_2",                    "1200"},
        {"z_perturb_1_value",              "1.10"},
        {"z_perturb_2_value",              "0.95"},
        {"ReceiverWaypoints",           "2"},
        {"ReceiverWaypoint0",           "1351.0, 371.0"},
        {"ReceiverWaypoint1",           "1351.0, 1631.0"},
        {"FWIReceiverIncludeLastWaypoint", "1"},
        {"ReceiverCount0",              "32"},
        {"UseSparseMatrix",                "1"},
        {"Qfactor",                        "15"},
        {"numL",                           "0"},
        {"SpaceRadius",                    "100"},
        {"measurement_space",              "point"},
        {"measurement_time",                     "point"},
        {"MeasureComp",                          "0"},
        {"source_component",                     "2"},
        {"dampingFlux",                          "1"},
        {"allowPlotting_M",                      "1"},
        {"allowPlotting_WF",                     "0"},
        {"plotFactor",                           "5"},
        {"source_factor",                        "1e15"},
        {"parametrization",                      "taup_positive"},
        {"T",                                    "0.8"},
        {"dt",                                   "0.0005"},
        {"deg",                                  "0"},
        {"level",                                "0"},
        {"TimeVerbose",                          "1"},
        {"TimeVerboseStep",                      "50"},
        {"plot_tStep",                           "-1"},
        {"rkorder",                              "-302"},
        {"Kmax",                                 "150"},
        {"Keps",                                 "1e-07"},
        {"Overlap",                              "dG1"},
        {"debugAdjoint",                         "1"},
        {"debugFrechet",                         "1"},
        {"keepAu",                               "0"},
        {"LinearSolver",                         "LS"},
        {"LinearVerbose",                        "-1"},
        {"LinearSteps",                          "15"},
        {"LinearNthIterOutput",                  "1"},
        {"FWINonlinearSolver",                   "FWI_mSDREGINN"},
        {"Precon",                               "1"},
        {"useApproxHessian",                     "0"},
        {"AAORecalculateWFEveryOuter",           "1"},
        {"FWI_MaxInnerLoopSteps_mSDREGINN",      "20"},
        {"FWI_Gamma_mSDREGINN",                  "0.95"},
        {"FWI_Damping_mSDREGINN",                "1"},
        {"FWI_ThetaMax_mSDREGINN",               "0.9999999999"},
        {"FWI_ThetaInitial_mSDREGINN",           "0.4"},
        {"FWI_RegularizationStrategy_mSDREGINN", "0"},
        {"mSDREGINN_Verbose",                    "1"},
        {"mSDREGINN_Steps",                      "2"},
        {"mSDREGINN_LineSearchSteps",            "3"},
        {"mSDREGINN_Epsilon",                    "1e-10"},
        {"mSDREGINN_Reduction",                  "1e-05"},
        {"mSDREGINN_MinimalStepNumber",          "3"},
        {"FWIReconstructRho",                    "0"},
        {"FWIReconstructV_P",                    "1"},
};


#endif //FWI_FWITESTALLATONCE2D_HPP
