//
// Created by cr on 14.07.21.
//

#ifndef FWI_TESTFWIREDUCED1D_H
#define FWI_TESTFWIREDUCED1D_H

#include <string>
#include <map>

using ConfigMap = std::map<std::string,std::string>;
const ConfigMap TestFWIReduced1DConfigMap{
        {"ConfigVerbose",                  "2"},
        {"ForwardSolver",                  "VADGTS"},
        {"Distribution",                   "RCB"},
        {"Model",                          "FWIInverse_DGTS"},
        {"CountCellsOld",                  "0"},
        {"dim",                            "1"},
        {"Mesh",                           "oneDim"},
        {"Problem",                        "Benchmark1D"},
        {"startingValue_",                 "1"},
        {"Preconditioner_M",               "PointBlockJacobi"},
        {"Problem",                        "VAcousticWaveC2Benchmark"},
        {"ReconstructionType",             "Classical"},
        {"sourceSpace",                    "2"},
        {"useTaper",                       "0"},
        {"taperRadiusSource",              "0"},
        {"taperRadiusReceiver",            "100"},
        {"taperExponent",                  "-0.1"},
        {"taperIgnoreReceiverCells",       "1"},
        {"taperIgnoreSourceCells",         "0"},
        {"Monoparam",                      "Vp"},
        {"SignalName",                     "Ricker"},
        {"SignalFreq",                     "10"},
        {"SignalCutoff",                   "0"},
        {"SignalDelay",                    "0"},
        {"numberOfSourcesPerShot",         "1"},
        {"v_bg",                           "5.0"},
        {"x_perturb",                      "800"},
        {"z_perturb_0",                    "800"},
        {"z_perturb_0_value",              "1.5"},
        {"testAAO",                        "0"},
        {"z_perturb_1",                    "-9000"},
        {"z_perturb_2",                    "-11000"},
        {"z_perturb_0_value",              "1.0"},
        {"z_perturb_1_value",              "1.0"},
        {"z_perturb_2_value",              "1.0"},
        {"ReceiverWaypoints",           "2"},
                                          {"ReceiverWaypoint0", "2.11, 0"},
                                          {"ReceiverWaypoint1",           "3.43, 0"},
        {"ReceiverCount0",              "20"},
        {"UseSparseMatrix",                "1"},
        {"Qfactor",                        "15"},
        {"f_source",                       "10"},
        {"FWISourceWaypoints",             "2"},
                                          {"FWISourceWaypoint0", "0.51, 0"},
                                          {"FWISourceWaypoint1", "0.51, 0"},
                                          {"FWISourceCount0",                "1"},
        {"numL",                           "2"},
        {"SpaceRadius",                    "100"},
        {"measurement_space",              "point"},
        {"measurement_time",               "point"},
        {"MeasureComp",                    "0"},
        {"source_component",               "2"},
        {"dampingFlux",                    "1"},
        {"allowPlotting_M",                "1"},
        {"allowPlotting_WF",               "1"},
        {"plotFactor",                     "1"},
        {"parametrization",                "taup_positive"},
        {"T",                              "1.00"},
        {"dt",                             "0.005"},
        {"deg",                            "1"},
        {"level",                          "6"},
        {"TimeVerbose",                    "1"},
        {"TimeVerboseStep",                "50"},
        {"plot_tStep",                     "-1"},
        {"rkorder",                        "-2"},
        {"Kmax",                           "150"},
        {"Keps",                           "1e-07"},
        {"Overlap",                        "dG1"},
        {"debugAdjoint",                   "1"},
        {"debugFrechet",                   "1"},
        {"keepAu",                         "0"},
        {"LinearSolver",                   "LS"},
        {"LinearVerbose",             "-1"},
        {"LinearSteps",               "15"},
        {"LinearNthIterOutput",       "1"},
        {"LinearEpsilon",             "1e-15;"},
        {"LinearReduction",           "1e-14"},
        {"FWI_HierarchyLevel",        "-1"},
        {"FWI_Precon",                "0"},
        {"FWI_SaveAdjointWF        ", "0"},
        {"FWI_SaveSeis             ", "0"},
        {"FWI_DebugPlottingLevel   ", "5"},
        {"FWI_BacktrackingFactor   ", "0.1"},
        {"FWI_BacktrackingActivated", "1"},
        {"FWINonlinearSolver",        "FWI_CGREGINN"},
        {"CGREGINNType",                        "Canonic"},
        {"FWI_MaxInnerLoopSteps_CGREGINN",      "20"},
        {"FWI_Gamma_CGREGINN            ",      "0.9"},
        {"FWI_Damping_CGREGINN          ",      "1"},
        {"FWI_ThetaMax_CGREGINN         ",      "0.999"},
        {"FWI_ThetaInitial_CGREGINN     ",      "0.4"},
        {"FWI_RegularizationStrategy_CGREGINN", "0"},
        {"FWI_Gamma_CGREGINN            ",      "0.9"},
        {"CGREGINNCanonic_Verbose",             "5"},
        {"CGREGINNCanonic_Steps",               "10"},
        {"CGREGINNCanonic_LineSearchSteps",     "3"},
        {"CGREGINNCanonic_Epsilon",             "1e-10"},
        {"CGREGINNCanonic_Reduction",           "1e-05"},
        {"CGREGINNCanonic_MinimalReduction",    "1"},
        {"CGREGINNCanonic_MinimalStepNumber",   "0"},
        {"CGREGINNCanonic_NthIterOutput",       "1"},
        {"FWIReconstructRho",                   "0"},
        {"FWIReconstructV_P",                   "1"}
};
#endif //FWI_TESTFWIREDUCED1D_H
