#include "FWITestReducedPML2D.hpp"
#include "TestEnvironment.hpp"
#include "FWINonlinearSolvers.hpp"

std::vector<NonlinearOutput> FWIInverseMainDGTSVA();

class FWITestReducedPML2D : public Test {
public:
    FWITestReducedPML2D() {
        Config::Initialize(FWITestReducedPML2DMap);
    }

    void TearDown() override {
//        Config::close();
    }
};

TEST_F(FWITestReducedPML2D, TestFWIInverseMainDGTSVA) {
    std::vector<double> output = FWIInverseMainDGTSVA()[0][1];
    std::vector<double> input;
    MOUT(output);
    input = {0.229509613398787, 0.156173980740431, 0.0801709705294285, 0.0631273924524932};
    //    input = {
//            0.232711453251744,
//            0.147983016995337,
//            0.124318433339986,
//            0.119054610193642};
    for (int i = 0; i < output.size(); i++) {
        input[i] -= output[i];
        input[i] *= 1.0 / output[i];
    }
    EXPECT_VECTOR_NEAR(input, std::vector<double>(input.size(), 0.0), 1e-10);
}

int main(int argc, char **argv) {
    return MppTest(
            MppTestBuilder(argc, argv).
                    WithoutDefaultConfig().
                    WithScreenLogging().
                    WithConfPath("../").
                    WithGeoPath("../conf/geo/").
                    WithPlotPath("data/vtu/").
                    WithPPM()
    ).RUN_ALL_MPP_TESTS();
}
