//
// Created by cr on 04.11.22.
//

#ifndef FWI_FWITESTREDUCEDPML2D_HPP
#define FWI_FWITESTREDUCEDPML2D_HPP

#include <map>
#include <string>
using ConfigMap = std::map<std::string, std::string>;

const ConfigMap FWITestReducedPML2DMap{
        {"ConfigVerbose",                  "2"},
        {"ForwardSolver",                  " VADGTS"},
        {"Distribution",                   " RCB"},
        {"Model",                          " FWIInverse_DGTS"},
        {"Mesh",                           "Custom"},
        {"LeftBnd",                        "0"},
        {"RightBnd",                       "2000"},
        {"BottomBnd",                      "0"},
        {"TopBnd",                         "2000"},
        {"bnd",                            "1"},
        {"dimX",                           "21"},
        {"dimY",                           "21"},
        {"taupPlotLevel",                  "2"},
        {"SaveObservedSeismogram",         "1"},
        {"PaddingPML",                     "1"},
        {"PMLPaddingLength",               "300,300,500,500"},
        {"PMLBnds",                        "1,1, 1, 1"},
        {"PMLDistFactor",                  "1.15"},
        {"Problem",                        " VAcousticWaveC2Benchmark"},
        {"useTaper",                       "1"},
        {"taperRadiusSource",              "0"},
        {"taperRadiusReceiver",            "0"},
        {"taperExponent",                  "-0.1"},
        {"taperIgnoreReceiverCells",       "1"},
        {"taperIgnoreSourceCells",         "1"},

        {"Monoparam",                      " "},
        {"ReconstructionType",             " Classical"},
        {"ReceiverWaypoints",           " 2"},
    {"ReceiverWaypoint0", " 1351.0, 371.0"},
    {"ReceiverWaypoint1", " 1351.0, 1631.0"},
    {"ReceiverCount0",              " 32"},
        {"UseSparseMatrix",                "1"},
        {"Qfactor",                        "100"},
        {"f_source",                       " 25"},
        {"numL",                           " 1"},
        {"measurement_space",              " point"},
        {"measurement_time",               " point"},
        {"MeasureComp",                    " 0"},
        {"source_component",               " 2"},
        {"perturbation_comp",              " 2"},
        {"dampingFlux",                    " 0"},
        {"allowPlotting_M",                "1"},
        {"allowPlotting_WF",               "1"},
        {"plotfactor",                     " 10"},
        {"parametrization",                " taup_positive"},
//        {"parametrization",                " native"},

        {"T",                              "0.6"},
        {"dt",                             " 0.002"},
        {"FWISourceWaypoints",             "2"},
    {"FWISourceWaypoint0", "601,371"},
    {"FWISourceWaypoint1", "601,1621"},
    {"FWISourceCount0",                "2"},
        {"deg",                            " 1"},
        {"plevel",                         "0"},
        {"level",                          "0"},
        {"TimeVerbose",                    " 1"},
        {"plot_tStep",                     "-1"},
        {"rkorder",                        " -2"},
        {"Kmax",                           "150"},
        {"Keps",                           " 1e-07"},
        {"Overlap",                        " dG1"},
        {"debugAdjoint",                   " 0"},
        {"debugFrechet",                   " 1"},
        {"source_factor",                  " 24257425742.5742"},
        {"LinearSolver",                   " LS"},
//        {"Preconditioner_S",               "SuperLU_local"},
//        {"Preconditioner_S",               "PS"},
        {"LinearVerbose",                  " -1"},
        {"LinearSteps",                    "100"},
        {"LinearNthIterOutput",            " 1"},
        {"LinearEpsilon",                  " 1e-12"},
        {"LinearReduction",                " 0.0001"},
        {"FWINonlinearSolver",     " FWI_CGREGINN"},
        {"FWI_DebugPlottingLevel", " 1"},
        {"FWIReconstructRho",      " 1"},
        {"FWIReconstructKappa0",   " 1"},
        {"FWIReconstructV_P",      " 1"},
        {"FWIReconstructTauP",             " 1"},
        {"CGREGINNCanonic_Steps",          "3"},
};


#endif //FWI_FWITESTREDUCEDPML2D_HPP
