#ifndef _DGVISCOACOUSTICASSEMBLEBWD_HPP_
#define _DGVISCOACOUSTICASSEMBLEBWD_HPP_

#include <utility>

#include "DGAssemble.hpp"

class DGVAcousticAssembleBwd : public DGAssemble {
public:
  explicit DGVAcousticAssembleBwd(std::shared_ptr<ProblemVAcoustic> _prob, double t0, double T,
                                  double dt)
      : DGAssemble(std::move(_prob), false, 0, t0, T, dt) {}

  void FluxMatrix(Matrix &A) const override{
      DGAssemble::FluxMatrix(A, true, false);

    }

    void SystemMatrix(Matrix &S) const override {
        FluxMatrix(S);
    }

    void FluxMatrixOnly(Matrix &A) const override {
      DGAssemble::FluxMatrix(A, false, false);

    }

    void RHS(double t, Vector &b) const override {
      rhsAssembler->RHS(this->LastTStep() - t, b);
    }

    double L2Error(double t, const Vector &u) const override{
      return DGAssemble::L2Error(this->LastTStep() - t, u);

    }

    void PrintStep(double t, Vector &u, int step){
      DGAssemble::PrintStep(this->LastTStep() - t, u, step);

    }

    void get_u_int_assemble(double t, Vector &u) const override{
      DGAssemble::get_u_int_assemble(this->LastTStep() - t, u);

    }

    void SetInitialValue(Vector &u) override {
        DGAssemble::get_u_int_assemble(this->LastTStep(), u);
    }
};
#endif
